package game.gui;

import game.color.TextColor;
import game.gui.element.ActButton;
import game.gui.element.TransparentBox;
import game.init.Config;
import game.log.Log;

public class GuiInfo extends Gui {
	private static final String INFO = 
	TextColor.GREEN + "" + TextColor.BUG + "" + TextColor.BUG + "" + TextColor.BUG + " " + TextColor.VIOLET + "" + Config.VERSION + "" + 
	TextColor.GREEN + " " + TextColor.BUG + "" + TextColor.BUG + "" + TextColor.BUG + "\n" + 
	"\n" + 
	TextColor.LGRAY + "Ein Mod zur Simulation, zum Testen, für Rollenspiele, Multiplayer und vieles mehr." + "\n" + 
	"Optimiert für Geschwindigkeit, Stabilität und" + TextColor.UNKNOWN + "" + TextColor.UNKNOWN + " [Speicherzugriffsfehler]";

	private static final String[] AUTHORS = {
		TextColor.CYAN + "Sen der \"kleine\" Dämon " + TextColor.CRIMSON + TextColor.DEMON + TextColor.BLACK + TextColor.BLKHEART
	};
	private static final String[] LIBRARIES = {
		"LWJGL 3.3.6+1 (GLFW + OpenGL)",
		"Netty 4.1.119-Final",
		"Guava 33.4.0",
		"Albert Pham - WorldEdit",
		"Joonas Vali - NameGenerator",
		"LWJGL 2.9.4-nightly-20150209 - GLUProject"
	};

	public static final GuiInfo INSTANCE = new GuiInfo("Über dieses Programm", INFO + "\n\n" + getLibraries(false) + "\n\n" + getCredits(false) + "\n\n" + getColors());
	public static final GuiInfo HAX = new GuiInfo("Üb3r d1es3n Cr4ck", INFO + "\n\n" + getLibraries(true) + "\n\n" + getCredits(true) + "\n\n" + getColors());

	private final String header;
	private final String info;

	private static void addLines(StringBuilder sb, boolean hax, String alternate, String category, String... authors) {
		sb.append("\n" + (hax ? TextColor.BLUE : TextColor.GRAY) 
				+ (hax ? alternate : category) + ":\n    ");
		for(int z = 0; z < authors.length; z++) {
			if(z > 0)
				sb.append((hax ? TextColor.VIOLET : TextColor.GRAY) + ", ");
			sb.append((hax ? TextColor.DVIOLET : TextColor.WHITE) + authors[z]);
		}
	}

	private static String getLibraries(boolean hax) {
		StringBuilder sb = new StringBuilder((hax ? TextColor.RED : TextColor.YELLOW) + (hax ? "Genutzte Exploits" : "Verwendete Programmbibliotheken und Quellcode") + "\n" + 
				(hax ? TextColor.CYAN : TextColor.WHITE) + "=========================================================");
		for(String lib : LIBRARIES) {
			sb.append("\n" + TextColor.LGRAY + "  -> " + TextColor.NEON + lib);
		}
		return sb.toString();
	}
	
	private static String getColors() {
		StringBuilder sb = new StringBuilder();
		int num = 0;
		for(TextColor color : TextColor.values()) {
			if(num > 0)
				sb.append(' ');
			if((color.code >= Log.CHR_COLORS1 && color.code <= Log.CHR_COLORE1) || (color.code >= Log.CHR_COLORS2 && color.code <= Log.CHR_COLORE2)) {
				sb.append(color + "#" + (char)(num < 10 ? ('0' + num) : ('A' + (num - 10))));
				num++;
			}
		}
		return sb.toString();
	}

	private static String getCredits(boolean hax) {
		StringBuilder sb = new StringBuilder((hax ? TextColor.RED : TextColor.YELLOW) + (hax ? "Das Team -- TCQ" : "Mitwirkende") + "\n" + 
				(hax ? TextColor.CYAN : TextColor.WHITE) + "=========================================================");

		addLines(sb, hax, "Die dunklen Herrscher", "Mod geschrieben und designt von", 
				AUTHORS);
		addLines(sb, hax, "Absolut größter Lamer des Universums", "Ursprünglich geschaffen von", 
				"Markus Persson");
		addLines(sb, hax, "Crack und weitere Programmierung", "Spiel-Design, Programmierung und Grafiken", 
				"Jens Bergensten", "Nathan Adams", "Ryan Holtz", "Michael Stoyke");
		addLines(sb, hax, "Ressourcen entschlüsselt von", "Programmierung", 
				"Erik Broes", "Paul Spooner", "Ryan Hitchman", "Elliot Segal");
		addLines(sb, hax, "Cracktro, Grafiken und Intromusik", "Töne und Geräusche", 
				"Daniel Rosenfeld", "freesound.org");
		addLines(sb, hax, "Packing und Verbreitung", "Management, Administration und Spaß", 
				"Carl Manneh", "Daniel Kaplan", "Lydia Winters");
		addLines(sb, hax, "Server und Hosting", "Zahlen und Statistiken", 
				"Patrick Geuder");
		addLines(sb, hax, "Weiterer Dank geht an", "Entwickler von Mo' Creatures (Pferde usw.)", 
				"John Olarte", "Kent Christian Jensen", "Dan Roque");
		return sb.toString();
	}
	
	public GuiInfo(String header, String info) {
		this.header = header;
		this.info = info;
	}
	
	public void init(int width, int height) {
		this.add(new TransparentBox(10, 10, width - 20, height - 44, this.info));
		this.add(new ActButton(0, height - 24, width, 24, GuiMenu.INSTANCE, "Zurück"));
	}
	
	public String getTitle() {
		return this.header;
	}
}
